;----------------------------------------------------------------------------
;    LOGIT.X
;    ~~~~~~~~~~
;    Example file of "LogIt.XH" being used.  For other functions please
;    examine the header. You may call any subroutine in this
;    header file which does NOT begin with a '_'.
;----------------------------------------------------------------------------

/*--- Load common header ----------------------------------------------------*/
#define SBACKUP_ZIP                 "C:\TMP\BACKUP\BACKUP.ZIP"
#define SBACKUP_RESTORE_LOG         "C:\RESTORE.LOG"
#define SBACKUP_SERVER_DIR_FROM_WSN "L:\DATA"

/*--- Want to do logging ----------------------------------------------------*/
LogitFileName    = <$SBACKUP_RESTORE_LOG>;
LogitBackupLevel = 9;
LogitAbortHook   = 'DyingHook';
#define  INCL_EXECOS2CMD                   ;;Include Command Execution code
#include "LogIt.XH"

/*--- Initialization --------------------------------------------------------*/
address cmd '@echo off'
call SayAndLogIt   "Starting Restore of your servers's data...", Yellow;
if translate(arg(1)) <> 'YES' then
   call FailedNowDie 'You did not confirm restore with "YES".';

/*--- Change to server's data directory -------------------------------------*/
CurrentDir = directory(<$SBACKUP_SERVER_DIR_FROM_WSN>);
CurrentDir = directory(<$SBACKUP_SERVER_DIR_FROM_WSN> || '\');
if left(CurrentDir, length(<$SBACKUP_SERVER_DIR_FROM_WSN>)) <> <$SBACKUP_SERVER_DIR_FROM_WSN> then
   call FailedNowDie 'Could not change to the servers data directory (now at "' || CurrentDir || '").';

/*--- Restore server stuff --------------------------------------------------*/
UnzipCmd = 'IUNZIP.EXE -o ' || <$SBACKUP_ZIP>;
call ExecOs2Cmd  UnzipCmd;
if Rc = 0 then
do
   /*--- It worked!, no more to do ------------------------------------------*/
   call SayAndLogIt "Successfully Completed SERVER Restore.", Yellow;
   call OkExit;
end;

/*--- Display Error Message -------------------------------------------------*/
call FailedNowDie 'Failed to restore all files (check log for more details).';




/*===========================================================================*/
Alert:
/*===========================================================================*/
   /*--- Work out what the text of the alert should be ----------------------*/
   RestoreRc  = arg(1);
   RestoreMsg = arg(2);
   AlertText = 'SVRRES Server Restore~' || RestoreRc || '~' || RestoreMsg;

   /*--- Send the alert -----------------------------------------------------*/
   call RxFuncAdd  'RexAlertRexxPostString', 'RexAnz', 'RexAlertRexxPostString';
   RexRc = RexAlertRexxPostString(AlertText);
   return(RexRc);


/*===========================================================================*/
OkExit:
/*===========================================================================*/
   /*--- Create alert and exit ----------------------------------------------*/
   call Alert 0, "Successful";
   exit(0);


/*===========================================================================*/
DyingHook:
/*                                                                           */
/* All errors including rexx syntax traps etc end up here.                   */
/*===========================================================================*/
   /*--- Get Info -----------------------------------------------------------*/
   ExitRc     = arg(1);
   ExitReason = arg(2);

   /*--- Create alert and exit ----------------------------------------------*/
   call Alert ExitRc, ExitReason;
   call beep  800,80;
   call beep  900,80;
   call beep  800,80;
   exit(ExitRc);
